/********************************************************************************/
/* Programm     : MXFROMSQ.CMD                                                  */
/* Zweck        : Alle Squish - Areas suchen und Echoarea.ctl schreiben         */
/* Autor        : Thomas (W.) Mueller                                           */
/* EMail        : 2:2454/117@Fidonet,                                           */
/*                70:7101/1201@VPLNet                                           */
/*                81:449/5617@Kultnet                                           */
/*                142:1011/901@SFNet                                            */
/* Stand        : 06.12.1996                                                    */
/* Nach einer Idee von: Lutz Buchheister  / Dieter Rautenstengel / Ralph Theren */
/*------------------------------------------------------------------------------*/
/* Beschreibung : Es werden alle Echoareas aus der Squish.Cfg ausgelesen        */
/*                und daraus eine Echoarea.Ctl fr Maximus erzeugt.             */
/*                Dabei koennen Areas zu Gruppen zusammengefasst werden.        */
/*                Areabeschreibungen werden aus einem externen File gelesen.    */
/*------------------------------------------------------------------------------*/
/* Installation : In der MSGAREA.CTL werden nur noch lokale und die Netmail     */
/*                Am Ende der MSGAREA.CTL wird dann noch die Zeile              */
/*                      INCLUDE ECHOAREA.CTL                                    */
/*                angehaengt.                                                   */
/*------------------------------------------------------------------------------*/
/* History      : 19.03.95  1.00 erste Version                                  */
/*                19.08.95  1.10 an Maximus 3.0 angepasst                       */
/*                               (nicht mehr fr 2.x verwenden!!)               */
/*                27.08.95  3.00 jetzt mit division-Unterstuetzung von Max 3.0  */
/*                06.12.96  3.01 TYPE-Keyword bei Gruppen hinzugefuegt          */
/********************************************************************************/

CALL RXFUNCADD 'SYSLOADFUNCS','REXXUTIL','SYSLOADFUNCS'
CALL SYSLOADFUNCS

CALL SysCurState OFF

Header.1 = '͸'
Header.2 = '    MAX from SQUISH MSG-Areaconverter                        Version 3.01  '
Header.3 = '                                                                           '
Header.4 = '    (c) 1995-96 by Thomas (W.) Mueller, 2:2454/117@Fidonet                 '
Header.5 = '                                                                           '
Header.6 = 'nach einer Idee von Lutz Buchheister, Ralph Theren und Dieter Rautenstengel'
Header.7 = ';'
Header.0 = 7

CALL DisplayHeader

PARSE arg config

IF LENGTH(config) = 0 THEN DO
  config='mxfromsq.Cfg'
END
SAY 'ConfigFile: 'config

/* SAY 'config='config */

CALL SysFileTree config,'file','F'
IF file.0 = 0 THEN Do
  SAY "Die Konfigurationsdatei wurde nicht gefunden!"
  Exit
END

LogLevelChars.1 = '#'
LogLevelChars.2 = ':'
LogLevelChars.3 = '+'
LogLevelChars.4 = '!'

OutFile.0 = ''
SquishCfg=''
LogFile = ''
DescFile = ''
GroupCount = 0
DivCount = 0
DivDesc.0 = 'INCLUDEs und nicht zuordbare Areas'
DivStartNo.0 = 0
AreaKeyword.0 = 0
Hidden = 'Hidden'
StartNo = 0

Line = 0
DO UNTIL LINES(config)=0
  inline = TRANSLATE(Strip(Linein(config)),' ',d2c(09))
  Line = Line + 1
  IF (SUBSTR(inline,1,1) <> ";") & (LENGTH(inline) > 0) THEN Do
    PARSE UPPER VAR inline Keyword Value Rest
    SELECT
      WHEN Keyword='GROUP' THEN do
        CALL DisplayHeader
        GroupCount = GroupCount + 1
        CALL SysCurPos Header.0,0
        CALL ReadGroup Value, GroupCount
      END
      WHEN Keyword='DIVISION' THEN do
        CALL DisplayHeader
        DivCount = DivCount + 1
        CALL SysCurPos Header.0,0
        CALL ReadDivision Value, DivCount
      END
      WHEN Keyword = 'AREAKEYWORD' THEN do
        AreaKeyword.0 = AreaKeyword.0 +1
        i = AreaKeyword.0
        AreaKeyword.i = Value
        MsgStyle.i = Rest
        CALL SysCurPos Header.0+6+i,0
        SAY 'AreaKeyword: 'AreaKeyword.i', Style: 'Rest
      END
      WHEN Keyword = 'OUTFILE' THEN do
        OutFile.0 = Value
        CALL SysCurPos Header.0+1,0
        SAY 'OutFile: 'OutFile.0
      END
      WHEN Keyword = 'SQUISHCFG' THEN do
        SquishCfg = Value
        CALL SysCurPos Header.0+2,0
        SAY 'SquishCfg: 'SquishCfg
      END
      WHEN Keyword = 'LOGFILE' THEN do
        LogFile = Value
        CALL SysCurPos Header.0+3,0
        SAY 'LogFile: 'LogFile
      END
      WHEN Keyword = 'DESCFILE' THEN do
        DescFile = Value
        CALL SysCurPos Header.0+4,0
        SAY 'DescFile: 'DescFile
      END
      WHEN Keyword = 'HIDDEN' THEN do
        Hidden = Value
        CALL SysCurPos Header.0+5,0
        SAY 'Hidden-Level: 'Value
      END
      WHEN Keyword = 'STARTNO' THEN do
        StartNo = Value
        CALL SysCurPos Header.0+6,0
        SAY 'Default StartNo: 'Value
      END
      Otherwise
        SAY 'Fehler im Config-File, Zeile 'Line': 'inline
        Exit
    END /* SELECT */
  END /* IF */
END /* do until */

Ret=STREAM(config,c,'close')

IF OutFile.0 = '' THEN DO
  SAY 'Config-Fehler: Keine Ausgabedatei angegeben (OUTFILE).'
  EXIT
END
IF SquishCfg='' THEN DO
  SAY 'Config-Fehler: SQUISH.CFG nicht angegeben (SQUISHCFG).'
  EXIT
END
IF LogFile = '' THEN DO
  SAY 'Config-Fehler: Kein Log-File angegeben (LOGFILE).'
  EXIT
END
IF DescFile = '' THEN DO
  SAY 'Config-Fehler: Keine Description-Datei angegeben (DESCFILE).'
  EXIT
END
IF AreaKeyword.0 = 0 THEN DO
  SAY 'Config-Fehler: Kein Area-Keyword angegeben (AreaKeyword).'
  EXIT
END

CALL WriteLog 3,'Start, Max from Squish 3.00'

CALL DisplayHeader

DO i = 1 TO GroupCount          /* Nicht gesetzte Gruppenwerte auf Default */
  GroupDiv.i = FindDivision(GrpName.i)
  Div = GroupDiv.i
  SAY 'Division von Gruppe 'GrpName.i' ist 'DivName.Div
  CALL WriteLog 2,'Division of group 'GrpName.i' set to 'DivName.Div
  IF GrpRdACS.i = '' THEN DO
    GrpRdACS.i = GrpRdACS.GroupCount
    SAY 'ReadACS von Gruppe 'GrpName.i' auf Default ('GrpRdACS.i') gesetzt.'
    CALL WriteLog 2,'ReadACS of group 'GrpName.i' set to default ('GrpRdACS.i')'
  END
  IF GrpWrACS.i = '' THEN DO
    GrpWrACS.i = GrpWrACS.GroupCount
    SAY 'WriteACS von Gruppe 'GrpName.i' auf Default ('GrpWrACS.i') gesetzt.'
    CALL WriteLog 2,'WriteACS of group 'GrpName.i' set to default ('GrpWrACS.i')'
  END
  IF GrpOrigin.i = '' THEN DO
    GrpOrigin.i = GrpOrigin.GroupCount
    SAY 'Origin von Gruppe 'GrpName.i' auf Default ('GrpOrigin.i') gesetzt.'
    CALL WriteLog 2,'Origin of group 'GrpName.i' set to default ('GrpOrigin.i')'
  END
END

CALL DisplayHeader

CALL SysFileTree DescFile,'file','F'
IF file.0 = 0 THEN Do
  SAY "Die Datei "'DescFile'" wurde nicht gefunden!"
  Exit
END

DO i=1 TO AreaKeyword.0
  rc = SysFileSearch(AreaKeyword.i' ', squishcfg, "Area."i".")
  IF rc <> 0 THEN DO
    SAY 'Fehler beim Versuch die Datei 'squishcfg' einzulesen. ABBRUCH!'
    SAY 'Haben Sie den Parameter SQUISHCFG in der *.CFG korrekt definiert?'
    Exit
  END
END

SAY "Generating ECHOAREA-Files"

DO i=0 TO DivCount
  SAY "Division "DivName.i": "DivDesc.i
  SAY "Outfile: "Outfile.i
  CALL SysFileDelete(OutFile.i)                         /* altes File lschen */
  CALL LINEOUT OutFile.i,'% created at 'Date() Time()   /* Fileheader schreiben */
  DO j = 1 TO Header.0
    CALL LINEOUT OutFile.i,'%' Header.j
  END
  CALL LINEOUT OutFile.i,'%'
  IF i>0 THEN DO
    CALL LINEOUT OutFile.0,'% Division 'DivName.i': 'DivDesc.i
    CALL LINEOUT OutFile.0,'INCLUDE 'Outfile.i
    CALL LINEOUT OutFile.0,'%'
    CALL LINEOUT OutFile.i,'MsgDivisionBegin 'DivName.i' 'DivACS.i' . 'DivDesc.i
    CALL LINEOUT OutFile.i,'%'
  END
END

CALL DisplayHeader
SAY "Compiling ...                "

DO KeyWord = 1 TO AreaKeyword.0
  DO Anzahl = 1 TO Area.KeyWord.0
    /* In Grossbuchstaben und Tabs in Leerzeichen wandeln */
    Zeile = TRANSLATE(TRANSLATE(area.KeyWord.Anzahl,' ',d2c(09)))
    IF Subword(Zeile,1,1) = AreaKeyword.Keyword THEN DO
      PARSE UPPER VAR Zeile Dummy AreaTag Areapath Rest
      CALL SysCurPos Header.0+1,0
      AreaZone = 0
      AreaStyle = '*.MSG'
      PARSE VAR Rest Wort Rest
      PassThru = 0
      DO UNTIL (SUBSTR(Wort,1,1) <> '-') | PassThru
        Flag = SUBSTR(Wort,2,1)
        SELECT
          WHEN Flag = '0' THEN /* passthru */
            PassThru = 1
          WHEN Flag = '$' THEN
            AreaStyle = 'SQUISH'
          WHEN Flag = 'P' THEN
            AreaZone = SUBWORD(TRANSLATE(Wort,'   ','-P:'),1,1)
          OTHERWISE
            NOP
        END /* SELECT */
        PARSE VAR Rest Wort Rest
      END
      IF PassThru THEN
        ITERATE
      AreaStyle = AreaStyle' 'MsgStyle.KeyWord

      Group=-1
      DO i = 1 TO GroupCount UNTIL Group<>-1
        DO j = 1 TO GrpAreas.i.0 UNTIl Group<>-1
          IF MatchAreatag(GrpAreas.i.j,AreaTag) THEN
            Group = i
        END
        IF Group = -1 THEN
          IF AreaZone<>0 THEN
            IF AreaZone=GrpZone.i THEN
              Group=i
      END
      IF Group = -1 THEN DO
        SAY 'Fehler: Keine Gruppe fr Area 'AreaTag' gefunden'
        CALL WriteLog 4,'No group found for area 'AreaTag
        ITERATE
      END

      IF GrpRdACS.Group=Hidden THEN /* Hidden, nicht einbinden */
        ITERATE

      CALL SysFileSearch AreaTag,DescFile,'Desc'
      AreaDesc = ''
      DO i = 1 TO Desc.0
        IF AreaTag = SUBWORD(TRANSLATE(Desc.i,' ',d2c(09)),1,1) THEN DO
          AreaDesc = SUBWORD(TRANSLATE(Desc.i,' ',d2c(09)),2)
          LEAVE
        END
      END
      IF AreaDesc = '' THEN DO
        AreaDesc = AreaTag
        CALL WriteLog 3,'No description 'AreaTag
      END

      SAY AreaTag'                      '
      SAY 'AreaStyle 'AreaStyle' '
      IF AreaZone=0 THEN
        SAY 'Zone=default      '
      ELSE
        SAY 'Zone='AreaZone'      '
      SAY 'Gruppe 'GrpName.Group'                    '
      SAY 'Beschreibung: 'AreaDesc||COPIES(' ',80-4-LENGTH(AreaDesc))

      Div = GroupDiv.Group
      DivFile = Outfile.Div

      AreaNo = GrpStartNo.Group
      IF AreaNo='' THEN DO
        AreaNo = DivStartNo.Div
        DivStartNo.Div = AreaNo+1
      END
      ELSE
        GrpStartNo.Group = AreaNo+1

      /* AreaNo zweistellig machen */
      IF AreaNo<10 THEN DO
        AreaNo='0'AreaNo
      END;/* ELSE; IF AreaNo<100 THEN DO
        AreaNo='0'AreaNo
      END*/

      AreaReadACS = GrpRdACS.Group
      AreaWriteACS = GrpWrACS.Group
      AreaOrigin = GrpOrigin.Group
      AreaStyle = AreaStyle' 'GrpStyle.Group

      CALL LINEOUT DivFile,'MsgArea 'AreaNo
      CALL LINEOUT DivFile,'  ACS          'AreaReadACS
      CALL LINEOUT DivFile,'  Style        'AreaStyle
      CALL LINEOUT DivFile,'  Tag          'AreaTag
      CALL LINEOUT DivFile,'  Desc         'AreaDesc
      CALL LINEOUT DivFile,'  path         'AreaPath

      IF LENGTH(AreaOrigin)>0 THEN
        CALL LINEOUT DivFile,'  Origin 'AreaOrigin

      IF AreaWriteACS <> '' THEN DO
        IF AreaWriteACS <> AreaReadACS THEN DO
          CALL LINEOUT DivFile,'  Override     MESSAGE Msg_Enter 'AreaWriteACS
          CALL LINEOUT DivFile,'  Override     MESSAGE Msg_Reply 'AreaWriteACS
          CALL LINEOUT DivFile,'  Override     MESSAGE Msg_Change 'AreaWriteACS
          CALL LINEOUT DivFile,'  Override     MESSAGE Msg_Upload 'AreaWriteACS
        END
      END

      CALL LINEOUT DivFile,'End Area'
      CALL LINEOUT DivFile,'%'

    END /* IF */
  END /* DO Anzahl */
END /* DO */

DO i=0 TO DivCount
  SAY "Closing Outfile: "Outfile.i
  IF i>0 THEN DO
    CALL LINEOUT OutFile.i,'MsgDivisionEnd'
  END
  CALL LINEOUT Outfile.i           /* Ausgabefile schliessen */
END

CALL WriteLog 3,'End, Max from Squish 3.00'

SAY "Closing Logfile"
CALL LINEOUT Logfile

CALL DisplayHeader
SAY " "
SAY "Das war's ..."

cs = SysCurState(On)
CALL SysDropFuncs
Return

/**********************/
/***** Prozeduren *****/
/**********************/

/* liest eine komplette Gruppe aus dem Config-File */
ReadGroup: PROCEDURE EXPOSE Config Line GrpName. GrpAreas. GrpStartNo. GrpOrigin. GrpKeys. GrpZone. GrpRdACS. GrpWrACS. GrpStyle.
  ARG Group, idx

  i=0
  PARSE VALUE SysCurPos() WITH Zeile Spalte
  AreaZeile = Zeile+2
  AreaSpalte = 7

  /* mit Nullwerten initialisieren */
  GrpStartNo.idx = ''
  GrpOrigin.idx = ''
  GrpKeys.idx=''
  GrpZone.idx=0
  GrpRdACS.idx=''
  GrpWrACS.idx=''
  GrpStyle.idx=''

  GrpName.idx = Group

  SAY 'Gruppe    Zone Strt Keys      Read      Write     Origin'
  SAY Group||COPIES(' ',79-LENGTH(Group))
  SAY 'Areas:'COPIES(' ',79-6-LENGTH(Group))
  DO z=AreaZeile+1 TO 24
    CALL SysCurPos z,0
    CALL CHAROUT ,COPIES(' ',79)
  END

  DO UNTIL Keyword = 'END' | LINES(config)=0
    inline = TRANSLATE(STRIP(LINEIN(config)),' ',D2C(09))
    Line = Line + 1
    IF (SUBSTR(inline,1,1) <> ";") & (LENGTH(inline) > 0) THEN DO
      PARSE UPPER VAR inline Keyword Value Rest
      Values=SUBWORD(inline,2)
      SELECT
        WHEN Keyword = 'AREA' THEN DO
          i = i + 1
          GrpAreas.idx.i = Value
          Spalte = AreaSpalte + LENGTH(Value) + 1
          IF Spalte>79 THEN DO
            AreaZeile = AreaZeile + 1
            Spalte = LENGTH(Value) +1
            AreaSpalte = 0
          END
          CALL SysCurPos AreaZeile,AreaSpalte
          CALL CHAROUT, Value
          AreaSpalte = Spalte
        END
        WHEN Keyword = 'ZONE' THEN DO
          GrpZone.idx = Value
          CALL SysCurPos Zeile+1,10
          CALL CHAROUT, Value
        END
        WHEN Keyword = 'STARTNO' THEN DO
          GrpStartNo.idx = Value
          CALL SysCurPos Zeile+1,15
          CALL CHAROUT, Value
        END
        WHEN Keyword = 'ACS' THEN DO
          GrpRdACS.idx = Value
          GrpWrACS.idx = Value
          CALL SysCurPos Zeile+1,40
          CALL CHAROUT, Value
          CALL SysCurPos Zeile+1,30
          CALL CHAROUT, Value
        END
        WHEN Keyword = 'READACS' THEN DO
          GrpRdACS.idx = Value
          CALL SysCurPos Zeile+1,30
          CALL CHAROUT, Value
        END
        WHEN Keyword = 'WRITEACS' THEN DO
          GrpWrACS.idx = Value
          CALL SysCurPos Zeile+1,40
          CALL CHAROUT, Value
        END
        WHEN Keyword = 'TYPE' THEN DO
          GrpStyle.idx = Values
          CALL SysCurPos Zeile+1,50
          CALL CHAROUT, Values
        END
        WHEN Keyword = 'ORIGIN' THEN DO
          GrpOrigin.idx = Values
          CALL SysCurPos Zeile+1,60
          CALL CHAROUT, SUBSTR(Values,20)
        END
        WHEN Keyword = 'END' THEN
          NOP
      OTHERWISE
        SAY 'Fehler im Config-File, Zeile 'Line': 'inline
      END /* SELECT */
    END /* IF */
  END /* DO FOREVER */
  GrpAreas.idx.0 = i
RETURN

/* liest eine Division aus dem Config-File */
ReadDivision: PROCEDURE EXPOSE Config Line StartNo DivName. DivDesc. Outfile. DivGroups. DivStartNo. DivACS.
  ARG Div, idx

  i=0
  PARSE VALUE SysCurPos() WITH Zeile Spalte
  GroupSpalte = 10

  /* mit Nullwerten initialisieren */
  DivGroups.idx.0 = 0
  DivStartNo.idx = StartNo
  Outfile.idx = ""
  DivDesc.idx = "<no description>"

  DivName.idx = Div

  SAY 'Division  Groups                        Outfile                                '
  SAY Div||COPIES(' ',79-LENGTH(Div))
  DO z=Zeile+2 TO 24
    CALL SysCurPos z,0
    CALL CHAROUT ,COPIES(' ',79)
  END

  DO UNTIL Keyword = 'END' | LINES(config)=0
    inline = STRIP( TRANSLATE( LINEIN(config) ,' ',D2C(09) ) )
    Line = Line + 1
    IF (SUBSTR(inline,1,1) <> ";") & (LENGTH(inline) > 0) THEN DO
      PARSE UPPER VAR inline Keyword Value Rest
      Values=SUBWORD(inline,2)
      SELECT
        WHEN Keyword = 'GROUP' THEN DO
          i = i + 1
          DivGroups.idx.i = Value

          CALL SysCurPos Zeile+1,GroupSpalte
          CALL CHAROUT, Value
          GroupSpalte = GroupSpalte + LENGTH(Value) + 1
        END
        WHEN Keyword = 'DESCRIPTION' THEN DO
          DivDesc.idx = Values
          CALL SysCurPos Zeile+2,10
          CALL CHAROUT, Values
        END
        WHEN Keyword = 'OUTFILE' THEN DO
          OutFile.idx = Value
          CALL SysCurPos Zeile+1,40
          CALL CHAROUT, Value
        END
        WHEN Keyword = 'STARTNO' THEN DO
          DivStartNo.idx = Value
          CALL SysCurPos Zeile+1,15
          CALL CHAROUT, Value
        END
        WHEN Keyword = 'ACS' THEN DO
          DivACS.idx = Value
          CALL SysCurPos Zeile+1,30
          CALL CHAROUT, Value
        END
        WHEN Keyword = 'END' THEN
          NOP
      OTHERWISE
        SAY 'Fehler im Config-File, Zeile 'Line': 'inline
        CALL WriteLog 4,'error in config file, line 'Line': 'inline
      END /* SELECT */
    END /* IF */
  END /* DO FOREVER */
  DivGroups.idx.0 = i
  CALL SysCurPos 20,1
RETURN

FindDivision: PROCEDURE EXPOSE DivGroups. DivCount
  Arg GroupName

  True = 1
  False = 0

  Div = 0
  Found = False
  DO i=1 TO DivCount
    DO j=1 TO DivGroups.i.0
      IF DivGroups.i.j = GroupName THEN DO
        Found = True
        Div = i
        LEAVE
      END
    END
    IF Found=True THEN
      LEAVE
  END
RETURN Div

/* In Match ist nur ein * erlaubt, */
/* der entweder am Anfang oder am Ende stehen mu */
MatchAreatag: PROCEDURE
  ARG Match,Tag

  p = POS('*',Match)
  l = LENGTH(Match)
  SELECT
    WHEN p=0 THEN
      NOP
    WHEN p=1 THEN DO
      Tag = SUBSTR(REVERSE(Tag),1,l-1)
      Match = REVERSE(SUBSTR(Match,2))
    END
    WHEN p = l THEN DO
      Tag = SUBSTR(Tag,1,l-1)
      Match = SUBSTR(Match,1,l-1)
    END
    OTHERWISE
      SAY 'Fehlerhafter Match 'Match
      SAY 'Der * mu am Anfang oder Ende stehen.'
      Exit
  END /* SELECT */
RETURN (Tag = Match)

WriteLog: PROCEDURE EXPOSE Logfile LoglevelChars.
  PARSE ARG Loglevel,Zeile

  CALL LINEOUT Logfile,LoglevelChars.Loglevel SUBWORD(Date(),1,2) Time() 'MXSQ' Zeile
RETURN

DisplayHeader: PROCEDURE EXPOSE Header.
  CALL SysCLS
  Do i = 1 To Header.0
    SAY Header.i
  END
RETURN


